const query = require("../db.js");
const { toSnakeCase } = require("./utils.js");

const getRecordsCount = async (req, res) => {
  try {
    const { tableName } = req.params;
    const dBtableName = toSnakeCase(tableName);

    const tableCheck = await query(`
      SELECT EXISTS (SELECT 1 FROM pg_tables WHERE tablename = $1)
      AS table_exists`, [dBtableName]);
    if (!tableCheck.rows[0]["table_exists"]) {
      return res.status(404).json({ error: `Data collection ${tableName} not found.` });
    }

    const result = await query(`SELECT COUNT(*) FROM ${dBtableName}`);
    if (result.rows[0].count) {
      res.status(200).json({ tableName, numRecords: result.rows[0].count});
    } else {
      res.status(404).json({ message: "Not found." });
    }

  } catch (err) {
    console.error("Error handling the request:", err);
    res
      .status(500)
      .json({ error: "An error occurred while processing the request" });
  }
};

module.exports = getRecordsCount;
